/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ACAO                                                     */
/* Tabela : ACAO                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 18/02/2003 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ACAO
BEFORE INSERT OR UPDATE OR DELETE
ON ACAO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUACAO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL,0) <> NVL(:NEW.CDFILIAL,0)) OR
         (NVL(:OLD.NRACAO,0)   <> NVL(:NEW.NRACAO,0)) THEN
         :NEW.DTULTATUACAO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ACAO', '', 'CDFILIAL='||:OLD.CDFILIAL||';NRACAO='||:OLD.NRACAO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ACAO MODIFY DTULTATUACAO DEFAULT SYSDATE
/
