-- ================================================================== --
-- SISTEMA         : PONTO DE VENDA                         	      		        --
-- DATA DA CRIAO : INCIO - 31/03/2004                              		        --
-- CRIAO         : Renata Diniz                                			        --
-- OBJETIVOS       : Gerar vendas                                     			        --
-- @C:\WIN_V4\SQL\END_CONV\ORACLE\3842_PDVSTPO.SQL          	        --
-- ================================================================== --

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'GERA_VENDA_CATRACA' AND
	        TYPE = 'P' 		      AND
	        U.UID = O.UID                 AND
	        U.NAME = USER)
  DROP PROCEDURE GERA_VENDA_CATRACA
  GO


CREATE PROCEDURE GERA_VENDA_CATRACA(
  @P_CDFILIAL     VARCHAR(4),
  @P_CDOPERADOR   VARCHAR(12),
  @P_CDEMPRESA    VARCHAR(2),
  @P_DTINI        DATETIME,
  @P_DTFIN        DATETIME,
  @P_CDCLIENTE    VARCHAR(21),
  @P_CDCONSUMIDOR VARCHAR(21),
  @P_OPERADOR     VARCHAR(12),
  @P_ERRO         VARCHAR(100) OUTPUT 
 )AS
  DECLARE @V_DATA            VARCHAR(500);
  DECLARE @V_HORA            VARCHAR(500);
  DECLARE @V_DATAOLD         VARCHAR(500);
  DECLARE @V_CAIXA           VARCHAR(3);
  DECLARE @V_CDCLIENTE       VARCHAR(21);
  DECLARE @V_CDCONSUMIDOR    VARCHAR(500);
  DECLARE @V_CDCCUSCLIE      VARCHAR(500);
  DECLARE @V_CDTIPOCONS      VARCHAR(500);
  DECLARE @V_NMCONSUMIDOR    VARCHAR(500);
  DECLARE @V_CDIDCONSUMID    VARCHAR(500);
  DECLARE @V_INSERE          INT;
  DECLARE @V_CDSERVFILI      VARCHAR(500);
  DECLARE @V_CDPRODUTO       VARCHAR(500);
  DECLARE @V_CDCAIXA         VARCHAR(500);
  DECLARE @V_CDLOJA          VARCHAR(500);
  DECLARE @V_COUNT           NUMERIC;
  DECLARE @V_PRECO           FLOAT;
  DECLARE @V_PRECOCL         FLOAT;
  DECLARE @V_PRECOTOT        FLOAT;
  DECLARE @V_CDTABEPREC      VARCHAR(500);
  DECLARE @V_DTINIVGPREC     DATETIME;
  DECLARE @V_NRSEQUITVEND    VARCHAR(500);
  DECLARE @V_CDFILTABPREC    VARCHAR(500);
  DECLARE @V_CDTABEPRECCLI   VARCHAR(500);
  DECLARE @V_DTINIVGPRECCLI  DATETIME;
  DECLARE @V_IDREGDUP        VARCHAR(500);  /* Marcao de registro duplicado */
  DECLARE @V_IDPERMARCDUP    VARCHAR(500);  /* Permite marcao duplicada da Filial */
  DECLARE @V_IDREGDUPCATR    VARCHAR(500);  /* Permite marcao duplicada do Tipo de consumidor */
  DECLARE @V_CDCFILTABPRE    VARCHAR(500);
  DECLARE @V_CDTPCLIFILIAL   VARCHAR(500);
  DECLARE @V_DTINIVGPRECLIFIL DATETIME;
  DECLARE @V_DTABERTURA       DATETIME;
  DECLARE @V_CODVENDA        VARCHAR(500);
  DECLARE @V_CODMOVCXA       VARCHAR(500);
  DECLARE @V_CODMOVCLI       VARCHAR(500);
  DECLARE @V_CAIXAOLD        VARCHAR(500);
  DECLARE @V_COUNTABER       NUMERIC;
  DECLARE @V_CDTIPORECE      VARCHAR(10);     
  DECLARE @V_MESSAGE	     VARCHAR(500);
  DECLARE @V_MESSAGE2	     VARCHAR(500);
  DECLARE @V_NOVO_CODIGO     VARCHAR(500);
  DECLARE @V_NOVO_CODIGO2    VARCHAR(500);
  DECLARE @V_NOVO_CODIGO3    VARCHAR(500);
  DECLARE @V_NOVO_CODIGO4    VARCHAR(500);
  DECLARE @V_NOVO_CODIGO5    VARCHAR(500);
  DECLARE @V_NOVO_CODIGO6    VARCHAR(500);
  DECLARE @V_NOVO_CODIGO7    VARCHAR(500);
  DECLARE @V_NOVO_CODIGO8    VARCHAR(500);
  DECLARE @V_DTIMPLOGCAT     DATETIME;
  DECLARE @V_DSDTHRLOGCAT    VARCHAR(500);
  DECLARE @V_CDCAIXLOGCAT    VARCHAR(500);
  DECLARE @V_IDREGDUPLICADO  VARCHAR(500);
  DECLARE @V_NRIDENLOGCAT    VARCHAR(500);
  DECLARE @V_CDPROD	     VARCHAR(500);
  DECLARE @V_NRSEQLOGCAT     VARCHAR(500);
  DECLARE @V_NRSEQARQIMP     VARCHAR(500);
  DECLARE @V_DSOBSLOGCAT     VARCHAR(500);
  DECLARE @V_LOGCATMSG       VARCHAR(500);
  DECLARE @V_CONTROLE        VARCHAR(1);
  DECLARE @V_STTIPOCONS      VARCHAR(2);
  DECLARE @V_CDFILIALDIA     VARCHAR(5);
  DECLARE @V_CDTABEPREDIA    VARCHAR(4);
  DECLARE @V_DTINIVIGDIA     DATETIME;
  DECLARE @V_STDIA           VARCHAR(5);
  DECLARE @V_STDIAT          VARCHAR(5);
  DECLARE @V_DTFERIFILI      DATETIME;
  DECLARE @V_PRECODIA        FLOAT;
  DECLARE @V_PERCVAL         VARCHAR(5);
  DECLARE @V_DESCACRE        VARCHAR(5);
  DECLARE @V_TPCONSDIA       VARCHAR(2);
  DECLARE @V_IDVISUACUPOM    VARCHAR(1);
  DECLARE @V_PRECODESC       FLOAT;
  DECLARE @V_PRECOACE        FLOAT;
  DECLARE @V_VRTOTVENDA      FLOAT;

BEGIN
   SELECT @V_COUNT = MAX(CDTIPORECE)
   FROM TIPORECE
   WHERE IDTIPORECE = 'A';
   IF @V_COUNT IS NULL
      SET @P_ERRO = 'No h tipo de recebimento dbito consumidor cadastrado.';
   IF @P_ERRO IS NULL BEGIN 
   SET @V_NRSEQUITVEND = '001';
   SET @V_LOGCATMSG = '  Produto no importado devido  falta de preo. ';
   DECLARE CUR_LOGCATRACA CURSOR FOR
       SELECT NRSEQLOGCAT, CDCAIXLOGCAT, DSDTHRLOGCAT, NRIDENLOGCAT, 
              NRSEQARQIMP , IDREGDUPLICADO, DTIMPLOGCAT
       FROM   LOGCATRACA
       WHERE
          (CDFILIAL     = @P_CDFILIAL) AND 
          (CONVERT(VARCHAR, DTIMPLOGCAT, 103) BETWEEN 
	  (CONVERT(VARCHAR, CONVERT(DATETIME, @P_DTINI), 103)) AND
	  (CONVERT(VARCHAR, CONVERT(DATETIME, @P_DTFIN), 103)))
          AND (IDSIMPLOGCAT = 'P')
          AND (IDCRALOGCAT  = '2')
          AND (IDCATLOGCAT  = '2')
          AND (IDDATLOGCAT  = '2')
          AND (IDSERLOGCAT  = '2')
          AND (IDPROLOGCAT  = '2')
          AND (IDDUPLOGCAT  = '2')
          AND (IDCRAHABFILI = '2')
       ORDER BY DTIMPLOGCAT;
       OPEN CUR_LOGCATRACA;
       FETCH NEXT FROM CUR_LOGCATRACA INTO @V_NRSEQLOGCAT, @V_CDCAIXLOGCAT, @V_DSDTHRLOGCAT, @V_NRIDENLOGCAT, @V_NRSEQARQIMP, @V_IDREGDUPLICADO, @V_DTIMPLOGCAT
       WHILE (@@FETCH_STATUS = 0)   BEGIN
	 SET @V_CONTROLE = '2';
          SET @V_DATAOLD = '0';
	  SET @V_DATA  = SUBSTRING(@V_DSDTHRLOGCAT, 1, CHARINDEX(' ', @V_DSDTHRLOGCAT));
          SET @V_HORA  = SUBSTRING(@V_DSDTHRLOGCAT, CHARINDEX(' ', @V_DSDTHRLOGCAT) + 1, 8);
          SET @V_CAIXA = @V_CDCAIXLOGCAT;
          SET @V_DTABERTURA = CONVERT(DATETIME, @V_DSDTHRLOGCAT)
          SET @V_INSERE     = 0;
          SET @V_IDREGDUP   = @V_IDREGDUPLICADO;
      /* Traz os dados do consumidor, referente a filial de importao */
         SELECT @V_CDCLIENTE = MAX(CO.CDCLIENTE), @V_CDCONSUMIDOR = MAX(CO.CDCONSUMIDOR), @V_CDTIPOCONS = MAX(CO.CDTIPOCONS), 
	 @V_NMCONSUMIDOR = MAX(CO.NMCONSUMIDOR), @V_CDCCUSCLIE = MAX(CO.CDCCUSCLIE), @V_CDIDCONSUMID = MAX(CO.CDIDCONSUMID)
         FROM   CONSUMIDOR CO, CLIENFILIAL CL
         WHERE (CO.CDIDCONSUMID = @V_NRIDENLOGCAT	     )
         AND   (CO.IDSITCONSUMI = '1'                        )
         AND   (CO.CDCLIENTE    = CL.CDCLIENTE               )
         AND   (CL.CDFILIAL     = @P_CDFILIAL                );

      /* Traz os dados do consumidor, caso o cliente deste consumidor no esteja para nenhuma filial*/
      IF @V_CDCLIENTE IS NULL BEGIN
         SELECT @V_COUNT = COUNT(*)
         FROM (SELECT CO.CDCLIENTE, CO.CDCONSUMIDOR, CO.CDTIPOCONS, CO.NMCONSUMIDOR, CO.CDCCUSCLIE, CO.CDIDCONSUMID
               FROM CONSUMIDOR CO
               WHERE (CO.CDIDCONSUMID = @V_NRIDENLOGCAT)
                 AND (CO.IDSITCONSUMI = '1')
                 AND (CO.CDCLIENTE NOT IN (SELECT CL.CDCLIENTE
                                           FROM CLIENFILIAL CL
                                           WHERE CL.CDCLIENTE = CO.CDCLIENTE))) P
	 IF @V_COUNT = 0 BEGIN
	    SET @P_ERRO = ('Crach ' + @V_NRIDENLOGCAT +', no est associado a filial de importao. Favor associar o cliente a filial de importao.');
        BREAK;
     END;
     IF @V_COUNT > 1 BEGIN
	    SET @P_ERRO = ('Crach '+ @V_NRIDENLOGCAT +', no est associado a filial de importao. Favor associar o cliente correto a filial de importao.');
        BREAK;
     END;
            SELECT @V_CDCLIENTE = MAX(CDCLIENTE), @V_CDCONSUMIDOR = MAX(CDCONSUMIDOR), @V_CDTIPOCONS = MAX(CDTIPOCONS),
		   @V_NMCONSUMIDOR = MAX(NMCONSUMIDOR),@V_CDCCUSCLIE = MAX(CDCCUSCLIE), @V_CDIDCONSUMID = MAX(CDIDCONSUMID)
            FROM (SELECT CO.CDCLIENTE, CO.CDCONSUMIDOR, CO.CDTIPOCONS, CO.NMCONSUMIDOR, CO.CDCCUSCLIE, CO.CDIDCONSUMID
                  FROM CONSUMIDOR CO
                  WHERE (CO.CDIDCONSUMID = @V_NRIDENLOGCAT)
                    AND (CO.IDSITCONSUMI = '1')
                    AND (CO.CDCLIENTE NOT IN (SELECT CL.CDCLIENTE
                                              FROM CLIENFILIAL CL
                                              WHERE CL.CDCLIENTE = CO.CDCLIENTE))) G
      END; 
      IF @V_IDREGDUP = 'S' BEGIN
            SELECT @V_IDPERMARCDUP = MAX(IDPERMARCDUP)
            FROM   PARAVEND
            WHERE  CDFILIAL = @P_CDFILIAL;

         IF  @V_IDPERMARCDUP = 'S' BEGIN
               SELECT @V_IDREGDUPCATR = MAX(IDREGDUPCATR)
               FROM   TIPOCONS
               WHERE  CDTIPOCONS = @V_CDTIPOCONS;
         END;
      END;
      /* Insere venda de registro no duplicado ou
       Insere venda de registro duplicado que permite marcao duplicada */
      IF ((@V_IDREGDUP = 'N') OR
          (@V_IDREGDUP = 'S') AND (@V_IDPERMARCDUP = 'S') AND (@V_IDREGDUPCATR = 'S')) BEGIN
	 SET @V_NOVO_CODIGO = ('PEDIDOVENDA'+@P_CDFILIAL+@V_CAIXA);
         EXEC TEKNISA.NOVO_CODIGO @V_NOVO_CODIGO, @P_SEQUENCIAL = @V_CODVENDA OUTPUT;
         SET @V_CODVENDA  = (SUBSTRING(@V_CODVENDA, 11, 10));

      	 SET @V_NOVO_CODIGO2 = ('MOVCAIXA'+@P_CDFILIAL+@V_CAIXA+CONVERT(VARCHAR, @V_DTABERTURA));
         EXEC TEKNISA.NOVO_CODIGO @V_NOVO_CODIGO2, @P_SEQUENCIAL = @V_CODMOVCXA OUTPUT;
         SET @V_CODMOVCXA = (SUBSTRING(@V_CODMOVCXA, 11, 10));

         SET @V_NOVO_CODIGO3 = ('MOVCLIE'+@V_CDCLIENTE);
         EXEC TEKNISA.NOVO_CODIGO @V_NOVO_CODIGO3, @P_SEQUENCIAL = @V_CODMOVCLI OUTPUT;
         SET @V_CODMOVCLI = (SUBSTRING(@V_CODMOVCLI, 11, 10));

         IF (@V_DATAOLD <> @V_DATA) OR (@V_INSERE = 1) OR (@V_CAIXAOLD <> @V_CAIXA) BEGIN
            /* Gera o novo cdigo para a nova data */
         SET @V_NOVO_CODIGO4 = ('PEDIDOVENDA'+@P_CDFILIAL+@V_CAIXA);
         EXEC TEKNISA.NOVO_CODIGO @V_NOVO_CODIGO4, @P_SEQUENCIAL = @V_CODVENDA OUTPUT;
         SET @V_CODVENDA  = (SUBSTRING(@V_CODVENDA, 11, 10));

         SET @V_NOVO_CODIGO5 = ('MOVCLIE'+@V_CDCLIENTE);
         EXEC TEKNISA.NOVO_CODIGO @V_NOVO_CODIGO5, @P_SEQUENCIAL = @V_CODMOVCLI OUTPUT;
         SET @V_CODMOVCLI = (SUBSTRING(@V_CODMOVCLI, 11, 10));

         SET @V_DATAOLD  = @V_DATA;
         SET @V_CAIXAOLD = @V_CAIXA;
            SELECT @V_COUNTABER = COUNT(*)
            FROM   TURCAIXA
            WHERE  CDFILIAL   = @P_CDFILIAL AND
                   CDCAIXA    = @V_CAIXA    AND
                   DTABERCAIX = @V_DTABERTURA;
         IF @V_COUNTABER = 0 BEGIN
               INSERT INTO TURCAIXA
                  (CDFILIAL, CDCAIXA, DTABERCAIX, CDOPERABER, DTMOVTURCAIX, CDOPERADOR,
                   DTFECHCAIX, CDOPERFECH)
               VALUES
                  (@P_CDFILIAL, @V_CAIXA, @V_DTABERTURA, @P_CDOPERADOR,
                   @V_DATA, @P_CDOPERADOR, @V_DATA, @P_CDOPERADOR);
               SET @V_INSERE = 0;
	    END;
         END;	
         /* Verifica se existe servio  e produto definidos para o horrio da venda */
         SELECT @V_CDSERVFILI = MAX(SVT.CDSERVFILI)
         FROM   SERVTURCAIXA SVT
         WHERE (SVT.CDFILIAL     = @P_CDFILIAL  ) AND
               (SVT.CDCAIXA      = @V_CAIXA     ) AND
               ((((SVT.HRINISERTUR <= SUBSTRING(@V_HORA,1,2)+SUBSTRING(@V_HORA,4,2)) AND (SVT.HRFINSERTUR >= SUBSTRING(@V_HORA,1,2)+SUBSTRING(@V_HORA,4,2))) AND (SVT.HRINISERTUR < SVT.HRFINSERTUR)) OR
                (((SVT.HRINISERTUR <= SUBSTRING(@V_HORA,1,2)+SUBSTRING(@V_HORA,4,2)) OR  (SVT.HRFINSERTUR >= SUBSTRING(@V_HORA,1,2)+SUBSTRING(@V_HORA,4,2))) AND (SVT.HRINISERTUR > SVT.HRFINSERTUR)));
         IF @V_CDSERVFILI IS NULL BEGIN
            SET @P_ERRO = 'Horrio sem servio definido.';
            BREAK;
         END;
         ELSE BEGIN
            SELECT @V_CDPRODUTO = MAX(PT.CDPRODUTO)
            FROM   PRODTURCAIXA PT
            WHERE  (PT.CDFILIAL  = @P_CDFILIAL) AND
                   (PT.CDCAIXA   = @V_CAIXA   ) AND
                   (PT.CDSERVFILI   = @V_CDSERVFILI);
            IF @V_CDPRODUTO IS NULL BEGIN
               SET @P_ERRO = 'Servio sem produto cadastrado.';
               BREAK;          
            END;
          END;
         SELECT   @V_CDCAIXA = MAX(CDCAIXA), @V_CDLOJA = MAX(CDLOJA)
            FROM     CAIXA
            WHERE    (CDFILIAL = @P_CDFILIAL) AND
                     (CDCAIXA  = @V_CAIXA)
         /* Verifica se o caixa  grill */
         SELECT @V_COUNT = COUNT(*)
         FROM   CAIXA
         WHERE  (CDFILIAL    = @P_CDFILIAL) AND
                (CDCAIXA     = @V_CAIXA) AND
                (IDTIPOCAIXA = '2');
         /* Se for, deleta a ultima venda realizada para o consumidor */
         IF @V_COUNT <> 0 BEGIN
            DELETE FROM MOVICLIE
            WHERE CDFILIAL+CDCAIXA+NRSEQVENDA IN (SELECT CDFILIAL+CDCAIXA+MAX(NRSEQVENDA)
                                                    FROM   VENDA
                                                    WHERE  (DTENTRVENDA  = @V_DATA        ) AND
                                                           (CDCONSUMIDOR = @V_CDCONSUMIDOR)
                                                    GROUP BY CDFILIAL, CDCAIXA);
            DELETE FROM MOVCAIXA
            WHERE CDFILIAL+CDCAIXA+NRSEQVENDA IN (SELECT CDFILIAL+CDCAIXA+MAX(NRSEQVENDA)
                                                    FROM   VENDA
                                                    WHERE  (DTENTRVENDA  = @V_DATA        ) AND
                                                           (CDCONSUMIDOR = @V_CDCONSUMIDOR)
                                                    GROUP BY CDFILIAL, CDCAIXA);
            DELETE FROM ITEMVENDA
            WHERE CDFILIAL+CDCAIXA+NRSEQVENDA IN (SELECT CDFILIAL+CDCAIXA+MAX(NRSEQVENDA)
                                                    FROM   VENDA
                                                    WHERE  (DTENTRVENDA  = @V_DATA        ) AND
                                                           (CDCONSUMIDOR = @V_CDCONSUMIDOR)
                                                    GROUP BY CDFILIAL, CDCAIXA);
            DELETE FROM VENDA
            WHERE CDFILIAL+CDCAIXA+NRSEQVENDA IN (SELECT CDFILIAL+CDCAIXA+MAX(NRSEQVENDA)
                                                    FROM   VENDA
                                                    WHERE  (DTENTRVENDA  = @V_DATA        ) AND
                                                           (CDCONSUMIDOR = @V_CDCONSUMIDOR)
                                                    GROUP BY CDFILIAL, CDCAIXA);
	 END;
         /* Insere a venda */
         INSERT INTO VENDA
            (CDFILIAL   , CDCAIXA    , NRSEQVENDA , CDCLIENTE , CDEMPRESA, CDCONSUMIDOR, DTVENDA,
             DTENTRVENDA, IDSITUVENDA, CDFILIALTUR, CDCAIXATUR, DTABERTUR, CDSERVFILI  , CDOPERADOR,
             CDLOJA     , IDTIPOVENDA, CDCCUSCLIE , IDORIGEMVENDA, NRSEQARQIMP)
         VALUES
            (@P_CDFILIAL, @V_CAIXA, @V_CODVENDA, @V_CDCLIENTE, @P_CDEMPRESA, @V_CDCONSUMIDOR, @V_DTABERTURA,
             CONVERT(VARCHAR, @V_DATA, 103), 'O', @P_CDFILIAL, @V_CAIXA, @V_DTABERTURA, @V_CDSERVFILI  , @P_CDOPERADOR,
             @V_CDLOJA  , 'I'    , @V_CDCCUSCLIE, 'VND_CAT', '1'+SUBSTRING(@V_NRSEQARQIMP,2,10));
         /* Busca a tabela de preco vigente */
         /*Busca a tabela de preo configurada na tabela CLIENFILIAL*/
            SELECT @V_CDCFILTABPRE = MAX(CDCFILTABPRE), @V_CDTPCLIFILIAL = MAX(CDTABEPREC)
            FROM   CLIENFILIAL
            WHERE  CDCLIENTE = @V_CDCLIENTE AND
                   CDFILIAL  = @P_CDFILIAL;

         SELECT @V_DTINIVGPRECLIFIL = MAX(DTINIVGPREC)
         FROM   TABEVEND
         WHERE  (CDFILIAL   = @V_CDCFILTABPRE) AND
                (CDTABEPREC = @V_CDTPCLIFILIAL) AND
                (CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) BETWEEN DTINIVGPREC AND DTFINVGPREC);
	
         /*Busca a tabela de preo configurada na tabela Loja ou Filial*/
         SELECT @V_CDTABEPREC = MAX(LO.CDTABEPREC)
         FROM   LOJA LO, CAIXA CA
         WHERE (CA.CDFILIAL = @P_CDFILIAL )
           AND (CA.CDCAIXA  = @V_CDCAIXA  )
           AND (CA.CDFILIAL = LO.CDFILIAL)
           AND (CA.CDLOJA   = LO.CDLOJA  );

         IF @V_CDTABEPREC IS NULL BEGIN
            SELECT @V_CDTABEPREC = MAX(CDTABEPREC)
            FROM   PARAVEND
            WHERE  CDFILIAL = @P_CDFILIAL;
	 END;

         SELECT @V_DTINIVGPREC = MAX(DTINIVGPREC)
         FROM   TABEVEND
         WHERE  (CDFILIAL   = @P_CDFILIAL  ) AND
                (CDTABEPREC = @V_CDTABEPREC) AND
                   (CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) BETWEEN DTINIVGPREC AND DTFINVGPREC);

         /*Busca a tabela de preo configurada na tabela CLIENTE*/       
         SELECT @V_CDFILTABPREC = MAX(CDFILTABPREC), @V_CDTABEPRECCLI = MAX(CDTABEPREC)
         FROM CLIENTE
         WHERE CDCLIENTE = @V_CDCLIENTE;

         SELECT @V_DTINIVGPRECCLI = MAX(DTINIVGPREC)
         FROM   TABEVEND
         WHERE  (CDFILIAL   = @V_CDFILTABPREC ) AND
                (CDTABEPREC = @V_CDTABEPRECCLI) AND
                (   (CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103)) BETWEEN DTINIVGPREC AND DTFINVGPREC));
         DECLARE CUR_PRODUTO CURSOR FOR
             SELECT CDPRODUTO
             FROM   PRODTURCAIXA
             WHERE  (CDFILIAL = @P_CDFILIAL) AND
                    (CDCAIXA  = @V_CAIXA   ) AND
                    (CDSERVFILI = @V_CDSERVFILI)
	     ORDER BY CDPRODUTO
	 OPEN CUR_PRODUTO ;
         FETCH NEXT FROM CUR_PRODUTO  INTO @V_CDPROD;
  	 WHILE (@@FETCH_STATUS = 0)   BEGIN
            /* Busca o preo do produto */
            /* Se no tiver, verifica se tem preco cliente por filial */
            SELECT @V_PRECO = ISNULL(MAX(VRPRECITEM),0), @V_PRECOCL = ISNULL(MAX(VRPRECITEMCL),0)
            FROM   ITEMPRECO
            WHERE  (CDFILIAL     = @V_CDCFILTABPRE        ) AND
                   (CDTABEPREC   = @V_CDTPCLIFILIAL       ) AND
                   (DTINIVGPREC  = @V_DTINIVGPRECLIFIL    ) AND
                   (CDPRODUTO    = @V_CDPROD 		  ) AND
                   (CDPRPAITABPR = @V_CDPROD		  );

            SET @V_CDFILIALDIA  = @V_CDCFILTABPRE;
            SET @V_CDTABEPREDIA = @V_CDTPCLIFILIAL;
            SET @V_DTINIVIGDIA  = @V_DTINIVGPRECLIFIL;

            IF (@V_PRECO = 0) AND (@V_PRECOCL = 0) BEGIN
               /* Se no tiver, verifica se tem preco cliente */
               SELECT @V_PRECO = ISNULL(MAX(VRPRECITEM),0), @V_PRECOCL = ISNULL(MAX(VRPRECITEMCL),0)
               FROM   ITEMPRECO
               WHERE  (CDFILIAL     = @V_CDFILTABPREC        ) AND
                      (CDTABEPREC   = @V_CDTABEPRECCLI       ) AND
                      (DTINIVGPREC  = @V_DTINIVGPRECCLI      ) AND
                      (CDPRODUTO    = @V_CDPROD 	     ) AND
                      (CDPRPAITABPR = @V_CDPROD		     );

                SET @V_CDFILIALDIA  = @V_CDFILTABPREC;
                SET @V_CDTABEPREDIA = @V_CDTABEPRECCLI;
                SET @V_DTINIVIGDIA  = @V_DTINIVGPRECCLI;

               IF (@V_PRECO = 0) AND (@V_PRECOCL = 0) BEGIN
                  /* Se no tiver, verifica na tabela de preo padro */
                  SELECT @V_PRECO = ISNULL(MAX(VRPRECITEM),0), @V_PRECOCL = ISNULL(MAX(VRPRECITEMCL),0)
                  FROM   ITEMPRECO
                  WHERE  (CDFILIAL     = @P_CDFILIAL           ) AND
                         (CDTABEPREC   = @V_CDTABEPREC         ) AND
                         (DTINIVGPREC  = @V_DTINIVGPREC        ) AND
                         (CDPRODUTO    = @V_CDPROD	       ) AND
                         (CDPRPAITABPR = @V_CDPROD	       );

                  SET @V_CDFILIALDIA  = @P_CDFILIAL;
                  SET @V_CDTABEPREDIA = @V_CDTABEPREC;
                  SET @V_DTINIVIGDIA  = @V_DTINIVGPREC;
               END;
            END;     

          /* ##Calcular Preos Diferenciados (descontos, acrescimos)## */

          /* Tipo de consumidor */
            SET @V_STDIA = NULL;

            /* Verifica o dia do preo diferenciado */
            SELECT @V_STDIAT = ISNULL(MAX(NRDIASEMANPR),0)
            FROM  ITEMPRECODIA
            WHERE CDFILIAL     = @V_CDFILIALDIA
             AND CDTABEPREC    = @V_CDTABEPREDIA
             AND DTINIVGPREC   = @V_DTINIVIGDIA
             AND CDPRODUTO     = @V_CDPROD;

            SELECT @V_STTIPOCONS = ISNULL(MAX(CDTIPOCONS),'T')
            FROM   CONSUMIDOR
            WHERE (CDCLIENTE    = @V_CDCLIENTE   ) AND
                  (CDCONSUMIDOR = @V_CDCONSUMIDOR);

            /* Verificar o dia */
            /* Feriado */
            SELECT @V_DTFERIFILI = MAX(DTFERIFILI)
            FROM   FERIFILI
            WHERE (CDFILIAL   = @P_CDFILIAL)
              AND (DTFERIFILI = CONVERT(DATETIME, @V_DATA));

            IF (@V_DTFERIFILI IS NULL) BEGIN
              /* Vespera de Feriado */
              SELECT @V_DTFERIFILI = MAX(DTFERIFILI)
              FROM   FERIFILI
              WHERE (CDFILIAL   = @P_CDFILIAL)
                AND (DTFERIFILI = CONVERT(DATETIME, @V_DATA)+1);
            END;
            ELSE BEGIN
	       IF @V_STDIAT = 'F' BEGIN
               	  SET @V_STDIA = 'F';
 	       END;
               	 SET @V_DTFERIFILI = NULL;            
            END;

            IF NOT (@V_DTFERIFILI IS NULL) BEGIN
	       IF @V_STDIAT = 'V' BEGIN	       	
               	  SET @V_STDIA = 'V';
	       END;
            END;

            IF (@V_STDIA IS NULL) BEGIN
               /* Dia da semana */
               SELECT @V_STDIA = DATEPART(W,@V_DATA)		
            END;
           
            IF @V_STDIAT = 'T' BEGIN
               SET @V_STDIA = @V_STDIAT;
            END;

           /* Verifica desconto, acrescimo e tipo de consumidor*/            
            SELECT @V_PRECODIA = ISNULL(MAX(VRPRECODIA),0), @V_PERCVAL = MAX(IDPERVALORPR),
                   @V_DESCACRE = MAX(IDDESCACREPR), @V_TPCONSDIA = MAX(CDTIPOCONSPD),
                   @V_IDVISUACUPOM = MAX(IDVISUACUPOM)
            FROM   ITEMPRECODIA
            WHERE CDFILIAL      = @V_CDFILIALDIA
              AND CDTABEPREC    = @V_CDTABEPREDIA
              AND DTINIVGPREC   = @V_DTINIVIGDIA
              AND CDPRODUTO     = @V_CDPROD
              AND CDPRPAITABPR  = @V_CDPROD
              AND NRDIASEMANPR  = @V_STDIA
              AND SUBSTRING(@V_HORA,1,2)+SUBSTRING(@V_HORA,4,2) BETWEEN HRINIPRECDIA AND HRFINPRECDIA
              AND CONVERT(VARCHAR, @V_DATA, 103) BETWEEN DTINIVALPREC AND DTFINVALPREC;

            /* Verifica Tipo de Consumidor */
            IF NOT(@V_TPCONSDIA = 'T') BEGIN
              IF @V_TPCONSDIA <> @V_STTIPOCONS BEGIN
                SET @V_PRECODIA = '0';
              END;
            END;

            /* Calcula Preo */
            IF (@V_PRECODIA <> 0) BEGIN        
              IF @V_PERCVAL = 'V' BEGIN
                 IF @V_DESCACRE = 'A' BEGIN
                    SET @V_PRECOACE = @V_PRECODIA;
                    SET @V_PRECODESC = '0';
		 END
                 ELSE BEGIN
                    SET @V_PRECODESC = @V_PRECODIA;
                    SET @V_PRECOACE = '0';
 		 END;
              END;
              ELSE BEGIN
                 IF @V_DESCACRE = 'A' BEGIN
                    SET @V_PRECOACE = ((@V_PRECODIA / 100) * (@V_PRECO));
                    SET @V_PRECODESC = '0';
		 END
                 ELSE BEGIN
                    SET @V_PRECODESC = ((@V_PRECODIA / 100) * (@V_PRECO));
                    SET @V_PRECOACE = '0';
		 END;
              END;
            END;  

            IF (@V_PRECODIA = 0) BEGIN     
               SET @V_PRECODESC = '0';
               SET @V_PRECOACE = '0';
            END;

            /* Se o preo do produto no for 0, insere o item */
	    
            IF ((@V_PRECO <> 0) OR (@V_PRECOCL <> 0)) AND (@V_CONTROLE = 2) BEGIN
               IF  @V_IDVISUACUPOM = 'S' BEGIN
                  INSERT INTO ITEMVENDA
                     (CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND, QTPRODVEND, VRUNITVEND,
                      VRUNITVENDCL, VRACRITVEND, VRDESITVEND, CDPRODUTO)
                  VALUES
                     (@P_CDFILIAL, @V_CAIXA, @V_CODVENDA, @V_NRSEQUITVEND, 1,
                      @V_PRECO, @V_PRECOCL, @V_PRECOACE, @V_PRECODESC, @V_CDPROD);
               END ELSE BEGIN
                  INSERT INTO ITEMVENDA
                     (CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND, QTPRODVEND, VRUNITVEND,
                      VRUNITVENDCL, VRACRITVEND, VRDESITVEND, CDPRODUTO)
                  VALUES
                     (@P_CDFILIAL, @V_CAIXA, @V_CODVENDA, @V_NRSEQUITVEND, 1,
                      @V_PRECO + @V_PRECOACE - @V_PRECODESC  , @V_PRECOCL, 0, 0, @V_CDPROD);
               END;

               SET @V_NRSEQUITVEND = RIGHT(REPLICATE('0', 3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRSEQUITVEND) + 1)), '3');

               SELECT @V_CDTIPORECE = MAX(CDTIPORECE)-- AS CDTIPORECE
               FROM   TIPORECE
               WHERE  IDTIPORECE = 'A';
               SET @V_PRECOTOT = (@V_PRECO + @V_PRECOCL + @V_PRECOACE - @V_PRECODESC); 		
               SET @V_NOVO_CODIGO6 = 'MOVCAIXA'+@V_CDCLIENTE 
               EXEC TEKNISA.NOVO_CODIGO @V_NOVO_CODIGO6, @P_SEQUENCIAL = @V_CODMOVCXA OUTPUT;
               SET @V_CODMOVCXA = SUBSTRING(@V_CODMOVCXA, 11, 10);
               INSERT INTO MOVCAIXA
                  (CDFILIAL  , CDCAIXA   , DTABERCAIX, NRSEQUMOVI  , IDTIPOMOVIVE, VRMOVIVEND,
                   NRSEQVENDA, CDTIPORECE, DTHRINCMOV, DTMOVIMCAIXA, CDCLIENTE)
               VALUES
                  (@P_CDFILIAL , @V_CAIXA     , @V_DTABERTURA, @V_CODMOVCXA, 'E', @V_PRECOTOT,
                   @V_CODVENDA , @V_CDTIPORECE, GETDATE(), CONVERT(DATETIME, @V_DATA),
                   @V_CDCLIENTE);
               SET @V_NOVO_CODIGO7 = 'MOVCLIE'+ CONVERT(VARCHAR, @V_CDCLIENTE);
               EXEC TEKNISA.NOVO_CODIGO @V_NOVO_CODIGO7, @P_SEQUENCIAL = @V_CODMOVCLI OUTPUT;
               SET @V_CODMOVCLI = SUBSTRING(@V_CODMOVCLI, 11, 10);
               INSERT INTO MOVICLIE
                  (CDCLIENTE   , NRSEQMOVCLI , CDCONSUMIDOR, VRMOVCLI    , DTMOVCLI    ,
                   DSHISTMOV   , IDTIPMOCVLI , CDFILIAL    , CDCAIXA     , NRSEQVENDA  ,
                   DTABERCAIX  , NRSEQUMOVI  , CDTIPORECE  , VRSALDOCONS , VRMOVPESCONS,
                   VRSALDPECONS, CDOPERADOR  , DTATUMOVCLIE, DSATUMOVCLIE, DTMOVIMCLIE ,
                   CDOPERECSALD, DTRECMOVCLIE)
               VALUES
                  (@V_CDCLIENTE , @V_CODMOVCLI , @V_CDCONSUMIDOR, @V_PRECOTOT, @V_DTABERTURA,
                   NULL        , 'D'         , @P_CDFILIAL    , @V_CAIXA   , @V_CODVENDA  ,
                   @V_DTABERTURA, @V_CODMOVCXA , @V_CDTIPORECE  , NULL      , NULL        ,
                   NULL        , @P_CDOPERADOR, NULL          , NULL      , CONVERT(DATETIME, @V_DATA, 103),
                   NULL        , NULL);
               IF @V_PRECOCL > 0 BEGIN
	          SET @V_NOVO_CODIGO8 = 'MOVCLIE'+ CONVERT(VARCHAR, @V_CDCLIENTE);
                  EXEC TEKNISA.NOVO_CODIGO @V_NOVO_CODIGO8, @P_SEQUENCIAL = @V_CODMOVCLI OUTPUT;
                  SET @V_CODMOVCLI = SUBSTRING(@V_CODMOVCLI, 11, 10)
                  INSERT INTO MOVICLIE
                     (CDCLIENTE   , NRSEQMOVCLI , CDCONSUMIDOR, VRMOVCLI    , DTMOVCLI    ,
                      DSHISTMOV   , IDTIPMOCVLI , CDFILIAL    , CDCAIXA     , NRSEQVENDA  ,
                      DTABERCAIX  , NRSEQUMOVI  , CDTIPORECE  , VRSALDOCONS , VRMOVPESCONS,
                      VRSALDPECONS, CDOPERADOR  , DTATUMOVCLIE, DSATUMOVCLIE, DTMOVIMCLIE ,
                      CDOPERECSALD, DTRECMOVCLIE)
                  VALUES
                     (@V_CDCLIENTE , @V_CODMOVCLI , NULL        , @V_PRECOCL, @V_DTABERTURA,
                      NULL        , 'D'         , @P_CDFILIAL  , @V_CAIXA  , @V_CODVENDA  ,
                      @V_DTABERTURA, @V_CODMOVCXA , @V_CDTIPORECE, NULL     , NULL        ,
                      NULL        , @P_CDOPERADOR, NULL        , NULL     , CONVERT(DATETIME, @V_DATA, 103),
                      NULL        , NULL)
	        END;
            END
            ELSE BEGIN
            /*No insere o produto que no tem preo*/
	       SELECT @V_DSOBSLOGCAT = DSOBSLOGCAT FROM LOGCATRACA
               WHERE  (CDFILIAL    = @P_CDFILIAL        ) AND
                      (NRSEQLOGCAT = @V_NRSEQLOGCAT	);
               UPDATE LOGCATRACA
               SET    LOGCATRACA.DSOBSLOGCAT  = @V_DSOBSLOGCAT + @V_LOGCATMSG
               DELETE FROM ITEMVENDA
               WHERE CDFILIAL   = @P_CDFILIAL AND
                     CDCAIXA    = @V_CAIXA    AND
                     NRSEQVENDA = @V_CODVENDA; 

               DELETE FROM MOVICLIE
               WHERE CDFILIAL   = @P_CDFILIAL AND
                     CDCAIXA    = @V_CAIXA    AND
                     NRSEQVENDA = @V_CODVENDA; 

               DELETE FROM MOVCAIXA
               WHERE CDFILIAL   = @P_CDFILIAL AND
                     CDCAIXA    = @V_CAIXA    AND
                     NRSEQVENDA = @V_CODVENDA; 

               DELETE FROM VENDA
               WHERE CDFILIAL   = @P_CDFILIAL AND
                     CDCAIXA    = @V_CAIXA    AND
                     NRSEQVENDA = @V_CODVENDA; 

               SET @V_INSERE = 1;
	       SET @V_CONTROLE = '1';
	    END;

	 FETCH NEXT FROM CUR_PRODUTO  INTO @V_CDPROD;
         END;
	 CLOSE CUR_PRODUTO;
	 DEALLOCATE CUR_PRODUTO;
    SET @V_VRTOTVENDA = 0;
    SELECT @V_VRTOTVENDA = ISNULL(SUM(ROUND(QTPRODVEND * (VRUNITVEND + ISNULL(VRUNITVENDCL, 0)), 2, 1) - ISNULL(VRDESITVEND, 0) + ISNULL(VRACRITVEND, 0)), 0)
      FROM ITEMVENDA
     WHERE CDFILIAL   = @P_CDFILIAL
       AND CDCAIXA    = @V_CAIXA
       AND NRSEQVENDA = @V_CODVENDA;

    UPDATE VENDA
       SET VRTOTVENDA = ISNULL(@V_VRTOTVENDA, 0)
     WHERE CDFILIAL   = @P_CDFILIAL
       AND CDCAIXA    = @V_CAIXA
       AND NRSEQVENDA = @V_CODVENDA;
       
         /* Atualiza o saldo do consumidor*/
         /* Segundo o Sr. Ailton no  necessrio atualizar o saldo do consumidor na importao
           das venda da catraca. Dessa forma, haver uma melhora na performance da mesma.*/
         /* ATUALIZA_SALDO_CONS(@P_CDFILIAL, @V_CDCLIENTE, @V_CDCONSUMIDOR, @V_DTABERTURA, @P_CDOPERADOR);*/
         /* Atualiza a logcatracapk indicando que uma venda foi importada*/
      END;
      UPDATE LOGCATRACAPK
      SET NRSEQARQIMPK = '1'+SUBSTRING(NRSEQARQIMPK,2,10)
      WHERE NRSEQARQIMPK = @V_NRSEQARQIMP;
      IF ((@V_PRECO <> 0) OR (@V_PRECOCL <> 0)) AND (@V_CONTROLE = 2) BEGIN
	DELETE FROM
            LOGCATRACA
         WHERE
            (CDFILIAL    = @P_CDFILIAL   ) AND
            (NRSEQLOGCAT = @V_NRSEQLOGCAT);
      END;
   FETCH NEXT FROM CUR_LOGCATRACA INTO  @V_NRSEQLOGCAT, @V_CDCAIXLOGCAT, @V_DSDTHRLOGCAT, @V_NRIDENLOGCAT, 
					@V_NRSEQARQIMP, @V_IDREGDUPLICADO, @V_DTIMPLOGCAT
   END;
   CLOSE CUR_LOGCATRACA;
   DEALLOCATE CUR_LOGCATRACA;

   END;
END;
GO